unit
  coolmm;

{COOL MEMORY MANAGER by COOL HINST}

{note: now it works}

{$DEFINE D}

interface

const
  const_maxblocks=8;

type
  TAddress=longint;
  TMemBlockIndex=integer;

type
  TMemoryElement=record
    state:boolean;
    count:TMemBlockIndex;
  end;

type
  TMemoryMap=array[0..const_maxblocks]of TMemoryElement;

procedure
  InitializeMM(const _memoryblocksize, _memorysize:Taddress);

function
  GetMemory(const _size:TAddress):TAddress;

function
  FreeMemory(const addr:TAddress):boolean;

procedure PrintMemoryState;

implementation

const
  freeblock=false;

var
  map:TMemoryMap;
  memoryblocksize, memorysize:TAddress;
  bcount:TMemBlockIndex;

procedure
  InitializeMM(const _memoryblocksize, _memorysize:Taddress);
var
  i:TMemBlockIndex;
begin
  {$IFDEF D}WriteLn('<coolmm.InitializeMM>');{$ENDIF}
  memoryblocksize:=_memoryblocksize;
  memorysize:=_memorysize;
  bcount:=memorysize div memoryblocksize;
  {$IFDEF D}WriteLn('coolmm.bcount = ',bcount,
    '//total count of memory blocks');{$ENDIF}
  map[0].state:=not freeblock;
  for i:=1 to bcount-1 do
  begin
    map[i].state:=freeblock;
    map[i].count:=0;
  end;
  map[bcount].state:=not freeblock;
end;

function
  GetMemory(const _size:TAddress):TAddress;
var
  size:TAddress;
  i,ns,c1,c2,cs,b1,b2,bs,ts:TMemBlockIndex;
  fbs:boolean;
begin
  {$IFDEF D}WriteLn('GetMemory started, _size = ',_size); {$ENDIF}
  b2:=-1;
  size:=(_size div memoryblocksize) + memoryblocksize;
  {$IFDEF D}WriteLn('Getmemory.size = ',size); {$ENDIF}
  ns:=size div memoryblocksize;
  {$IFDEF D}WriteLn('Getmemory.ns=',ns,'//needed memory blocks count');{$ENDIF}
  bs:=bcount;
  ts:=0;
  fbs:=false;
  for i:=0 to bcount do
  begin
    if (map[i].state=freeblock)and(not fbs) then
    begin
      fbs:=true;
      c1:=i;
    end;
    if map[i].state<>freeblock then
    begin
      if fbs then
      begin
        c2:=i;
        cs:=c2-c1;
        fbs:=false;
        if cs=ns then
        begin
          b1:=c1;
          b2:=c2;
          bs:=cs;
          break;
        end;
        if cs>ns then
        begin
          if cs<=bs then
          begin
            b1:=c1;
            b2:=c2;
            bs:=cs;
          end;
        end;
      end;
    end;
    if map[i].state=freeblock then inc(ts);
  end;
  {$IFDEF D}WriteLn('Getmemory.bs=',bs,'//best block size');{$ENDIF}
  if (b2-b1)>=ns then b2:=b1+ns-1;
  {$IFDEF D}WriteLn('Getmemory - piece of memory : ',b1,' - ',b2);{$ENDIF}
  if b2=-1 then
  begin
    GetMemory:=-1;
    {$IFDEF D}WriteLn('Getmemory.b2=',b2,'//erroneus b2,exiting');{$ENDIF}
    exit;
  end;
  for i:=b1 to b2 do
  begin
    map[i].state:=not freeblock;
  end;
  map[b1].count:=b2-b1+1;
  GetMemory:=b1*memoryblocksize;
end;

function
  FreeMemory(const addr:TAddress):boolean;
var
  id,count,i:TMemBlockIndex;
begin
  id:=addr div memoryblocksize;
  if map[id].state=freeblock then
  begin
    FreeMemory:=false;
  end
  else
  begin
    count:=map[id].count;
    if count=0 then
    begin
      FreeMemory:=false;
      exit;
    end;
    for i:=id to id+count-1 do map[i].state:=freeblock;
    map[id].count:=0;
    FreeMemory:=true;
  end;
end;

procedure PrintMemoryState;
var
  i:TMemBlockIndex;
begin
  for i:=0 to bcount do
  case map[i].state of
    true: Write('X');
    false: Write('0');
  end;
  WriteLN;
end;

end.

