program sample;

{$DEFINE D}

uses
  coolmm;

const
  bytescount=17;
  memblocksize=1024;
  memcount=memblocksize*6;

type
  TBytes=record
    a1,a2:Taddress
  end;

var
  mem:array[0..memcount]of byte;

function
  CreateBytes:TBytes;
const
  methodname='CreateBytes';
var
  b:TBytes;
begin
  {$IFDEF D}
  WriteLN(methodname,' - getting memory, length = ',bytescount);
  {$ENDIF D}
  b.a1:=GetMemory(bytescount);
  {$IFDEF D}
  WriteLN(methodname,'- GetMemory done, addr = ',b.a1);
  {$ENDIF D}
  if b.a1>=0 then
  begin
    b.a2:=b.a1+bytescount;
    {$IFDEF D}
    WriteLN(methodname, '- Our''s bytes bounds = [',b.a1,'..',b.a2,'];');
    {$ENDIF D}
  end
  else
  begin
    WriteLn('CreateBytes - Can not create bytes, errcode = ',b.a1);
  end;
  CreateBytes:=b;
end;

procedure
  RandomBytes(var b:TBytes);
const
  methodname='RandomBytes';
var
  i:TAddress;
begin
  for i:=b.a1 to b.a2 do
    mem[i]:=random(100);
  randomize;
  {$IFDEF D}WriteLN(methodname,' - done.');{$ENDIF D}
end;

procedure
  SortBytes(var b:TBytes);
const
  methodname='SortBytes';
var
  v:byte;
  i,j:TAddress;
begin
  for i:=b.a1 to b.a2-1 do
  begin
    for j:=b.a1 to b.a2-1 do
    begin
      if mem[j]>mem[j+1] then
      begin
        v:=mem[j+1];
        mem[j+1]:=mem[j];
        mem[j]:=v;
      end;
    end;
  end;
  {$IFDEF D}WriteLN(methodname,' - done.');{$ENDIF D}
end;

procedure
  EchoBytes(const b:TBytes);
var
  i:TAddress;
begin
  for i:=b.a1 to b.a2 do
  begin
    Write(mem[i],' ');
  end;
  WriteLN;
end;

procedure FreeBytes
  (var b:TBytes);
const
  methodname='FreeBytes';
begin
  case FreeMemory(b.a1) of
    true:
    begin
      {$IFDEF D}WriteLN(methodname,' - done.'){$ENDIF D};
      b.a1:=0;
      b.a2:=0;
    end;
    not true: {$IFDEF D}WriteLN(methodname,' - error.'){$ENDIF D};
  end;
end;

const
  methodname='program sample';

var
  a:array[0..6] of TBytes;
  i,t:integer;

begin
  InitializeMM(memblocksize,memcount);
  {$IFDEF D}
  WriteLN(methodname,' - Memory initialized, blocksize = ',memblocksize,
    '; memory length = ',memcount);
  {$ENDIF D}
  for t:=1 to 2 do
begin
  for i:=0 to 2 do
  begin
  a[i]:=CreateBytes;
  RandomBytes(a[i]);
  EchoBytes(a[i]);
  SortBytes(a[i]);
  EchoBytes(a[i]);
  PrintMemoryState;
  end;
  for i:=0 to 2 do
  begin
  FreeBytes(a[i]);
  PrintMemoryState;
  WriteLN;
  end;
end;
  ReadLN;
end.

