
include 'kernel\386.inc'

init_protected_mode:

	; kernel code must be already loaded at address 0
	; DL must contain kernel size in pages

	cli				; disable interrupts
	cld

	xor	di,di			; create GDT
	mov	ax,1000h
	mov	es,ax
	mov	si,gdt_data
	mov	cx,GDT_ENTRIES*2
	rep	movsd
	xor	eax,eax
	mov	cx,800h/4 - GDT_ENTRIES*2
	rep	stosd
	lgdt	[gdt]			; load GDT register

	mov	eax,cr0
	or	al,1			; switch to protected mode
	mov	cr0,eax

	jmp	CODE_SEL:0		; jump to kernel init

gdt:
  dw 800h - 1
  dd 10000h

gdt_data:
  dw 0,0
  db 0,0,0,0
  dw 0FFFFh,0
  db 0,ds_access,11011111b,0
  dw 0FFFFh,0
  db 0,cs_access,01010000b,0
