
int_24h:
	push	ds es
	pusha
	cli
	or	ah,ah			; function 00h:
	jz	get_date_and_time	;  get current date and time
	cmp	ah,01h			; function 01h:
	je	set_date_and_time	;  set current date and time
	mov	[error_code],_function_unavailable
	jmp	int_error
  get_date_and_time:
	mov	al,32h			; RTC register 32h
	out	70h,al
	in	al,71h			; read century
	mov	dh,al
	mov	al,9			; RTC register 09h
	out	70h,al
	in	al,71h			; read year
	mov	dl,al
	shl	edx,16
	mov	al,8			; RTC register 08h
	out	70h,al
	in	al,71h			; read month
	mov	dh,al
	mov	al,7			; RTC register 07h
	out	70h,al
	in	al,71h			; read day
	mov	dl,al
	mov	[esp+14h],edx		; return date in EDX
	mov	al,4			; RTC register 04h
	out	70h,al
	in	al,71h			; read hour
	mov	ch,al
	mov	al,2			; RTC register 02h
	out	70h,al
	in	al,71h			; read minute
	mov	cl,al
	shl	ecx,16
	xor	al,al			; RTC register 00h
	out	70h,al
	in	al,71h			; read second
	mov	ch,al
	mov	[esp+18h],ecx		; return time in ECX
	jmp	int_ok
  set_date_and_time:			; ECX = new time, EDX = new date
	mov	[error_code],_invalid_value
	mov	eax,ecx
	mov	bl,59h
	shr	eax,8
	call	check_bcd		; check second number
	shr	eax,8
	call	check_bcd		; check minute number
	mov	bl,23h
	shr	eax,8
	call	check_bcd		; check hour number
	mov	eax,edx
	mov	bl,31h
	or	al,al			; day cannot be 0
	jz	int_error
	call	check_bcd		; check day number
	mov	bl,12h
	shr	eax,8
	or	al,al			; month cannot be 0
	jz	int_error
	call	check_bcd		; check month number
	mov	bl,99h
	shr	eax,8
	call	check_bcd		; check year number
	shr	eax,8
	call	check_bcd		; check century number
	mov	al,7			; RTC register 07h
	out	70h,al
	mov	al,dl
	out	71h,al			; write day
	mov	al,8			; RTC register 08h
	out	70h,al
	mov	al,dh
	out	71h,al			; write month
	shr	edx,16
	mov	al,9			; RTC register 09h
	out	70h,al
	mov	al,dl
	out	71h,al			; write year
	mov	al,32h			; RTC register 32h
	out	70h,al
	mov	al,dh
	out	71h,al			; write century
	xor	al,al			; RTC register 00h
	out	70h,al
	mov	al,ch
	out	71h,al			; write second
	shr	ecx,16
	mov	al,2			; RTC register 02h
	out	70h,al
	mov	al,cl
	out	71h,al			; write minute
	mov	al,4			; RTC register 04h
	out	70h,al
	mov	al,ch
	out	71h,al			; write hour
	jmp	int_ok
      check_bcd:
	cmp	al,bl
	ja	invalid_bcd
	and	al,0Fh
	cmp	al,9
	ja	invalid_bcd
	ret
      invalid_bcd:
	add	esp,4
	jmp	int_error
