;
;   STFS FILE/DIRECTORY DRIVER
;                               for MicroKernel (c) 2006 Dubrovin Alexei
;



;
; MAIN RECORD
;
	MR_BLOCK_COUNT		equ  0 ; u_dw
	MR_FREE_BLOCK_COUNT	equ  2 ; u_dw
	MR_CLAST_SIZE		equ  4 ; u_dw
	MR_LAST_WRITE		equ  6 ; u_dw
	MR_LAST_CHECK		equ  8 ; u_dw
	MR_RESERVEDA		equ 10 ; u_dw
	MR_RESERVEDB		equ 12 ; u_dw
	MR_RESERVEDC		equ 14 ; u_dw
	MR_VERSION		equ 16 ; u_db
	MR_KERNEL_DEF		equ 17 ; u_db
	MR_SIGNATURE		equ 18 ; u_dw


; FIRST STRUCTURE TABLE                             ; 1024 RECORDS
;
ST_OFFSET equ 20
	ST_PATCH		equ  0	; 32 byte
	ST_PARENT		equ 32	; u_dd
	ST_SIZE_COUNT		equ 36	; u_dd
	ST_PERMISSION		equ 40	; u_dw
	ST_DTIMEW		equ 42	; u_dd
	ST_DTIMER		equ 46	; u_dd


; FIRST CLASTER TABLE
;
CT_OFFSET equ (50)*1024+ST_OFFSET
	  CT_FREE_COUNT 	equ 0	; 2Byte

	  CT_DETERMIN		equ 0	; 2*1024 bite
					; FORMAT:
					;         (IN HEX)
					;         000     - FREE
					;         001-400 - NFILE
					;         401-800 - USED ANOTHER BLOCK
					;         801     - LAST IN FILE
					;         802     - LAST IN FILE (ANOTHER BLOCK)
					;         FFF     - BAD
	  CT_NCLASTER	  equ 1024*2	; 4*1024 byte
					; FORMAT: 32Bite


CLASTERS_OFFSET equ CT_OFFSET+2+1024*2+4*1024 ; (~56Kb for each 64Mb)

int_31h:
	push	ds es
	pusha
	cli
	cld
	push	FLAT_SEL
	pop	ds
	push	ds
	pop	es
; INSIDE FILE OPERATION
	or	ah,ah			; function 00h:
	jz	assign_file		;  Assign File with FDC var
	cmp	ah,01h			; function 01h:
	je	remove_file		;  Read Block from File (min 1Kb)
	cmp	ah,02h			; function 02h:
	je	remove_file		;  Write Block to File (min 1Kb)
	cmp	ah,03h			; function 03h:
	je	remove_file		;  Read Full File
	cmp	ah,04h			; function 04h:
	je	remove_file		;  Write Full File

; OUTSIDE FILE/DIRECTORY OPERATION
	cmp	ah,10h			; function 10h:
	je	remove_file		;  Create File/Dir
	cmp	ah,11h			; function 11h:
	je	remove_file		;  Rename File/Dir
	cmp	ah,12h			; function 12h:
	je	remove_file		;  Delete File/Dir
	cmp	ah,13h			; function 13h:
	je	remove_file		;  Search File/Dir
	cmp	ah,14h			; function 14h:
	je	remove_file		;  Search Next File/Dir
	cmp	ah,15h			; function 15h:
	je	remove_file		;  Set File/Dir Info
	cmp	ah,16h			; function 16h:
	je	remove_file		;  Get File/Dir Info


; File Sistem Operation


assign_file:
;
;        FDC 
;                                   :
;                                               AH - 0
;                                               AL - 0/1 = Block Buffer / Full Buffer
;                                              EBX - Point to FDC (38 byte)
;                                              ESI - Point To Full Patch ($OD <- End)
;                                              EDI - Point To Buffer
;                                  :
;                                              AH -   (0F - )
;                                             ESI - Point to FDC (38 byte)
;

remove_file:
	xor	BL,BL ;  BL   (ST_PARENT)
parserstep:
	call	parserslash
  ;      jmp     finddirect
parserslash_finish:
	jmp	int_ok


	parserslash:
      cmp	byte [ESI+1], 02Fh
      jnz	parserstep
      mov	[_I], 02h
L5:
      movzx	eax, cl
      cmp	[_I + eax], 02Fh
      jz	 L6
      movzx	eax, [_I]
      mov	edx, eax
      sub	edx, 02h
      mov	al, [esi + eax]
      mov	byte [edi + edx], al
      inc	[_I]
      jmp	L5
L6:
      movzx	eax, [_I]
      inc	eax
      mov	[_J], al
L8:
      movzx	eax, byte [esi]
      movzx	edx, byte [_J]
      cmp	eax, edx
      jae	 L9
      movzx	eax, byte [_I]
      mov	edx, eax
      sub	dl, byte  [_J]
      mov	al, byte  [esi + eax]
      mov	byte [_B3 + edx], al
      inc	byte [_I]
      jmp	L8
L9:
      mov	byte [esi], 0h
      movzx	eax, [_B3]
      mov	dword[ebp - 4], eax
      mov	byte [_I], 00h
L11:
      inc	byte [_I]
      movzx	eax, [_I]
      mov	edx, eax
      mov	al, byte [_B3 + eax]
      mov	byte [esi + edx], al
      mov	al, byte [_I]
      cmp	al, byte [ebp - 4]
      jb	 L11

_I db 0
_J db 0
_B3 db 256 DUP (?)



include 'ATA.inc'

; ---------------------------------------------------------------------------------------------------------------------

FDC :
	FDC_FileName	db 32 DUP (?)
	FDC_FileAttr	db ?			; Bits - 01234567       (0/1)
						;        0 - File Exist (Y/N)
						;        1 - Assigned   (Y/N)
						;        2 - Read       (Y/N)
						;        3 - Write      (Y/N)
						;        4 - NumberOfStructureElement_HB (0[0..511]/1[512..1023])
						;        5 - Buffer (Block Buffer / Full BUffer)
	FDC_NumberOfStructureTable dw ?
	FDC_NumberOfStructureElement_LB db ?
	FDC_BufferPointer	dw ?

; ---------------------------------------------------------------------------------------------------------------------

ff_rscx db 'STFS Driver for MicroKernel STIMUL'